unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  Menus, ExtCtrls, LazSerial, strutils, Crt;

type

  { TForm1 }

  TForm1 = class(TForm)
    Bevel1: TBevel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Edit1: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    LazSerial1: TLazSerial;
    ListBox1: TListBox;
    ListBox2: TListBox;
    MainMenu1: TMainMenu;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    OpenDialog1: TOpenDialog;
    LowRom: TRadioButton;
    HighRom: TRadioButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure HighRomChange(Sender: TObject);
    procedure LazSerial1RxData(Sender: TObject);


    procedure MenuItem2Click(Sender: TObject);
    procedure MenuItem3Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;
  stopBurn:boolean;
implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.MenuItem2Click(Sender: TObject);
var filename :string;
    Stream: TFileStream;
    B: Byte;
    address:integer;
begin
  if OpenDialog1.Execute then
   begin
     listbox1.Clear;
     listbox2.Clear;
     filename := OpenDialog1.Filename;
     if (length(filename) > 50 )then
      begin
        label1.Caption := 'File: ...' + RightStr(filename,50);
      end
     else  begin
       label1.Caption := 'File: ' + filename;
     end;

     // load the file into the memo1 field.
  Stream := TFileStream.Create(filename, fmOpenRead);
  label2.Caption:='Size: ' + inttostr(Stream.Size) + ' bytes';
  address:=0;
  while Stream.Position < Stream.Size do
  begin
    Stream.Read(B, 1);
    Listbox1.Items.Add(inttoHex(address,4) + ' -> ' + inttoHex(B,2));
    address:=address+1;
  end;
    Stream.Free;

  if address > 8192 then
    Highrom.Enabled:=true
  else
    Highrom.Enabled:=false;

  end;

end;

procedure TForm1.MenuItem3Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.Button1Click(Sender: TObject);
var  i:integer ;
     d:string ;
     h:string;
     ec:integer;
     rc:integer;
     startAddress,endAddress:integer;

begin
  // send all lines from Memo2 to the serial port
  ec:=0;
  rc:=0;
  Label6.Caption:='Errors: ' + inttostr(ec);
  Label7.Caption:='Retry: ' + inttostr(rc);
  listbox2.Clear;
  button3.Enabled:=true;
  stopBurn:=false;
  if lowrom.Checked then startAddress:=0;
  if highrom.Checked then startAddress:=8192;

  for i:=startAddress to startAddress + 8191 do
  begin
  if i mod 10 =0 then  application.processmessages;

  if stopBurn then break;



   listbox1.ItemIndex := i;
    h:=RightStr(listbox1.Items[i],2);
    if length(h) > 0 then
    begin
      lazSerial1.WriteData(char(Hex2Dec(h)));
      //Delay(3);
      // wait for the response
      while (lazSerial1.DataAvailable=false) do begin end;
      Delay(3);     // was 10
      d := lazserial1.ReadData;
      if rightstr(d,1) = '?' then
      begin
       ec:=ec+1;
       Label6.Caption:='Errors: ' + inttostr(ec);
       listbox2.items.add (RightStr(listbox1.Items[i],2) + ' -> ' + d ); // leftStr(d,Length(d)-1) + ' E');
       listbox2.ItemIndex := listbox2.Items.Count-1;
      end;
      if  rightstr(d,1) = '#' then
      begin
       rc:=rc+1;
       Label7.Caption:='Retry: ' + inttostr(rc);
       listbox2.items.add (RightStr(listbox1.Items[i],2) + ' -> ' + d ); //leftStr(d,Length(d)-1) + ' R');
       listbox2.ItemIndex := listbox2.Items.Count-1;
      end;

      if rightstr(d,1) = '!' then
      begin
       listbox2.items.add (RightStr(listbox1.Items[i],2) + ' -> ' + d); // leftStr(d,Length(d)-1));
       listbox2.ItemIndex := listbox2.Items.Count-1;
      end;

      label3.Caption:=inttostr(listbox1.Items.Count - i -1)  ;
      label3.Refresh;
      form1.Update;
    end;

  end;
  if lowrom.Checked and highrom.Enabled then highrom.Checked:=true;
  button3.Enabled:=false;
end;

procedure TForm1.Button2Click(Sender: TObject);
var d:string;
begin
  if lazSerial1.Active then
    begin
         lazSerial1.Close;
         button2.Caption:='Connect';
         Label8.caption :='Not connected';
         button1.Enabled:=false;
         button4.Enabled:=false;
         button5.Enabled:=false;
    end
  else
    begin

      lazSerial1.Device:=edit1.Text;
      try
        lazSerial1.Open;
        button2.Caption:='Close';
        // Wait for the welcome text
        while (lazSerial1.DataAvailable=false) do begin end;
        Delay(50);
        d := lazserial1.ReadData;
        Label8.caption :='Connected to ' + d;
        button1.Enabled:=true;
        button4.Enabled:=true;
        button5.Enabled:=true;
      except on exception do begin
        lazSerial1.Close;
        showmessage('Can not connect to ' + edit1.Text );
      end;
      end; // end of try
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  stopBurn:=true;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  lazSerial1.WriteData('P');
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  lazSerial1.WriteData('U');
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin

end;

procedure TForm1.FormCreate(Sender: TObject);
begin

  label3.Caption:='';
  label1.caption:='File :';
  label2.caption:='Size :';
end;

procedure TForm1.HighRomChange(Sender: TObject);
begin

end;

procedure TForm1.LazSerial1RxData(Sender: TObject);
begin

end;



end.


